<template>
  <el-card shadow="never" class="aui-card--fill">
    <div class="mod-sys__user">
      <search-bar :formConfigs="formConfig" ref="searchBarForm" @headBtnClick="buttonClick" />
      <base-table
        :table-props="tableProps"
        :page="listQuery.page"
        :limit="listQuery.limit"
        :table-data="tableData"
      >
        <method-btn
          v-if="tableBtn.length"
          slot="handleBtn"
          :width="100"
          :label="$t('handle')"
          :method-list="tableBtn"
          @clickBtn="handleClick"
        />
      </base-table>
      <pagination
        :limit.sync="listQuery.limit"
        :page.sync="listQuery.page"
        :total="listQuery.total"
        @pagination="getDataList"
      />
      <!-- 弹窗, 新增 / 修改 -->
      <base-dialog
        :dialogTitle="addOrEditTitle"
        :dialogVisible="addOrUpdateVisible"
        @cancel="handleCancel"
        @confirm="handleConfirm"
        :before-close="handleCancel"
      >
        <add-or-update ref="addOrUpdate" @successSubmit="successSubmit"></add-or-update>
      </base-dialog>
    </div>
  </el-card>
</template>

<script>
import basicPage from "@/mixins/basic-page";
import AddOrUpdate from './role-add-or-update'
import i18n from "@/i18n";
const tableProps = [
  {
    prop: "name",
    label: i18n.t("role.name"),
  },
  {
    prop: "remark",
    label: i18n.t("role.remark"),
  },
  {
    prop: "createDate",
    label: i18n.t("role.createDate"),
  },
];
const tableBtn = [
  {
    type: "edit",
    btnName: i18n.t("edit"),
  },
  {
    type: "delete",
    btnName: i18n.t("delete"),
  },
];
export default {
  mixins: [basicPage],
  data() {
    return {
      urlOptions: {
        getDataListURL: '/sys/role/page',
        deleteURL: '/sys/role',
      },
      tableProps,
      tableBtn,
      formConfig: [
        {
          type: "input",
          label: i18n.t("role.name"),
          placeholder: i18n.t("role.name"),
          param: "name",
        },
        {
          type: "button",
          btnName: i18n.t("query"),
          name: "search",
          color: "primary",
        },
        {
          type: "button",
          btnName: i18n.t("add"),
          name: "add",
          color: "primary",
          plain: true,
        },
      ],
    };
  },
  components: {
    AddOrUpdate,
  },
  methods:{
    //search-bar点击
    buttonClick(val) {
      switch (val.btnName) {
        case "search":
          this.listQuery.name = val.name;
          this.listQuery.page = 1;
          this.getDataList();
          break;
        case "add":
          this.addOrEditTitle = this.$t('add');
          this.addOrUpdateVisible = true;
          this.addOrUpdateHandle()
          break;
        default:
          console.log(val)
       }
    },
  }
};
</script>
